using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("CROCompany")]
    public partial class CRO : Entity, IAuditUpdate, IAuditAdd
    {
        public string CROName { get; set; } = string.Empty;
        public string CROCode { get; set; }

        public DateTime CreateTime { get; set; }
        public Guid CreateUserId { get; set; }
        public Guid UpdateUserId { get; set; }
        public DateTime UpdateTime { get; set; }
    }
}
