﻿using IRaCIS.Core.Domain.Models;
using System;
using System.Linq.Expressions;

namespace IRaCIS.Core.Infra.EFCore
{
    public class EntityVerifyExp<TEntity> where TEntity : Entity
    {
        //验证表达式树
        public Expression<Func<TEntity, bool>> VerifyExp { get; set; }

        //验证提示错误信息
        public string VerifyMsg { get; set; }

        public VerifyEnum verifyType { get; set; } = VerifyEnum.Both;

        public bool IsVerify { get; set; } = true;
    }

    public enum VerifyEnum
    {
        OnlyAdd = 1,

        OnlyUpdate = 2,

        Both = 3,
    }



}




