﻿using System;
using System.Collections.Generic;
using IRaCIS.Core.Domain.Share;

namespace IRaCIS.Core.Domain.Models
{
    public class QANotice : Entity
    {
        public Guid TrialId { get; set; }

        public Guid SubjectVisitId { get; set; }

        public Guid RelationId { get; set; }=Guid.Empty;

        public string Message { get; set; }

        public string StudyStatusStr { get; set; } = string.Empty;

        public DateTime SendTime { get; set; }

        public DateTime? DealTime { get; set; }

        public Guid FromUserId { get; set; }

        public string FromUser { get; set; }

        public string FromUserType { get; set; }

        public NoticeType NoticeTypeEnum { get; set; }

        public bool NeedDeal { get; set; }

        public virtual ICollection<QANoticeUser> QANoticeUserList { get; set; }

        public QANotice()
        {
            QANoticeUserList=new HashSet<QANoticeUser>();
        }

    }



}