﻿

namespace IRaCIS.Core.Infrastructure.Extention
{
    /// <summary>
    ///  此处是为了 后续代替 IsSuccess   IsSuccess暂时还是保留，接下来的接口判断现在用Code 判断   不用IsSuccess就好了

    /// </summary>
    public enum ApiResponseCodeEnum
    {
        //正常的                                      相当于之前的 IsSuccess = true
        OK = 0,

        //Api 输入参数有问题                           相当于之前的 IsSuccess = false
        ApiInputError = 1,

        //业务验证不通过                               相当于之前的 IsSuccess = false
        BusinessValidationFailed = 2,

        //数据不存在
        DataNotExist=3,

        //程序异常                                     相当于之前的 IsSuccess = false
        ProgramException = 4,

        //需要提示 ,需要提示  从Result 取数据                    
        NeedTips = 5

    }

    
 

}
